<template>
  <div class="contSecc">
    <div class="titulo">
      <link
        rel="stylesheet"
        href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
        integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk"
        crossorigin="anonymous"
      />
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Módulos Supervisión</strong>
    </div>

    <v-parallax
      src="https://vuetifyjs.com/static/doc-images/parallax/material2.jpg"
      height="100vh"
    >
      <v-layout row wrap align-center justify-center>
        <v-flex xs6 offset xs-1 sm6 offset-sm1 md6 offset-md1>
          <v-card class="elevation-2 cardTitDetalle">
            <v-card-title primary-title class="layout justify-center">
              <h4>Módulos Supervisión</h4>
            </v-card-title>
            <v-card-text>
              <v-row outlined dense>
                <v-col cols="3">Supervisor:</v-col>
                <v-col cols="9">
                  <strong>{{ this.nombreUsuario }}</strong>
                  ({{ this.idUsuario }})
                </v-col>
              </v-row>
              <v-row outlined dense>
                <v-col cols="3">Fecha:</v-col>
                <v-col cols="9">
                  <strong>
                    {{ this.fechaSQ }}
                    <br />
                  </strong>
                </v-col>
              </v-row>
              <v-row outlined dense>
                <v-col cols="3">Semana:</v-col>
                <v-col cols="9">
                  <strong>
                    {{ this.semana }}
                    <br />
                  </strong>
                </v-col>
              </v-row>
              <v-row outlined dense>
                <v-col cols="3">Fase:</v-col>
                <v-col cols="9">
                  <strong>
                    {{ this.nombreFase }}
                    <br />
                  </strong>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-flex>
      </v-layout>
    </v-parallax>

    <div class="contSecc">
      <!--  termina parametrizado-->

      <div class="gris">
        <div class="contSecc">
          <div class="divBuscador">
            <div class="padding">
              <v-text-field
                v-model="search"
                class="buscador"
                append-icon="mdi-magnify"
                label="Buscar..."
                clearable
                single-line
                hide-details
              ></v-text-field>
            </div>
          </div>

          <!--  tabla-->
          <v-data-table
            :headers="encabezadoTareas"
            :items="modulos"
            :page.sync="page"
            :items-per-page="itemsPerPage"
            @page-count="pageCount = $event"
            :search="search"
            class="tblGeneral tblReporte"
          ></v-data-table>
        </div>
      </div>

      <div style="margin: 25px 10px 50px 10px">
        <v-btn
          color="primary"
          dark
          @click="downExcel()"
          :disabled="disabledBtnDownload"
          class="btnDisabled"
        >
          <strong style="fond-size : 16px; color:  #000;"
            >Descargar a Excel</strong
          >
        </v-btn>
      </div>
    </div>

    <v-dialog v-model="dlgMensaje" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>{{ titMensaje }}</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <strong>{{ txtMensaje }}</strong>
          </div>
          <br />
          <div class="tCenter">
            <v-btn color="primary" dark @click="dlgMensaje = false">
              <strong style="fond-size : 16px; color:  #000;">OK</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import router from "@/router";
import FileSaver from "file-saver";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;

import moment from "moment";

export default {
  name:
    "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento",

  data() {
    return {
      semana: "",
      idUsuario: "",
      nombreFase: "",
      disabledBtnDownload: true,
      //   DIALOGS
      dlgMensaje: false,
      titMensaje: "",
      txtMensaje: "",
      tareasRealizadas: [],
      //pagina
      pageCount: 1,
      page: 1,
      itemsPerPage: 20,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
        //  Params para regresar a Segundo Nivel
        paramsNivel_2: "",
        fechaInicio: "",
        fechaFin: "",
        idTerritorio: "",
        territorio: "",
        responsable: "",
        valueTrimestre: "",
        targetTrimestre: "",
        valueAldia: "",
        targetAldia: "",
        rangoSemanas: "",
        rangos: "",
        //habilita botones
        habilitaFechaFin: true,
      },
      encabezadoTareas: [
        { text: "Nombre Checklist", value: "nombreChecklist", align: "center" },
        { text: "Hora Entrada", value: "horaEntrada", align: "center" },
        { text: "Hora Salida", value: "horaSalida", align: "center" },
        { text: "Horas Trabajadas", value: "horasTrabajadas", align: "center" },
        { text: "ID Ceco", value: "idCeco", align: "center" },
      ],
      modulos: [],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name:
              "supervision_mantenimiento_dashboard_primer_nivel_mantenimiento_supervision",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Territorio",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_dashboard_segundo_nivel",
            params: {
              responsable: this.responsable,
              territorio: this.territorio,
              idTerritorio: this.idTerritorio,
              fechaInicio: this.fechaInicio,
              fechaFin: this.fechaFin,
              valueTrimestre: this.valueTrimestre,
              targetTrimestre: this.targetTrimestre,
              valueAldia: this.valueAldia,
              targetAldia: this.targetAldia,
              rangoSemanas: this.rangoSemanas,
              rangos: this.rangos,
              //paramsNivel_2: this.paramsNivel_2   no va en "View lista"
            },
          },
        },
        {
          text: "Detalle Semana Supervisor",
          disabled: true,
          to: {
            name:
              "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento_lista",
          },
        },
        {
          text: "Detalle Día Supervisor",
          disabled: true,
          to: {
            name:
              "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento_detalle",
          },
        },
        {
          text: "Módulos Supervisión",
          disabled: true,
        },
      ],
    };
  },
  beforeCreate() {
    let parametros = this.serviceCommons.base64ToObject(
      this.$route.query.parametros
    );

    this.paramsNivel_2 = parametros.paramsNivel_2;

    if (this.paramsNivel_2) {
      let parmsJson = JSON.parse(this.paramsNivel_2);
      console.log("Params Nivel 2 - rangos: " + parmsJson.rangos);

      this.fechaInicio = parmsJson.fechaInicio;
      this.fechaFin = parmsJson.fechaFin;
      this.idTerritorio = parmsJson.idTerritorio;
      this.territorio = parmsJson.territorio;
      this.responsable = parmsJson.responsable;
      this.valueTrimestre = parmsJson.valueTrimestre;
      this.targetTrimestre = parmsJson.targetTrimestre;
      this.valueAldia = parmsJson.valueAldia;
      this.targetAldia = parmsJson.targetAldia;
      this.rangoSemanas = parmsJson.rangoSemanas;
      this.rangos = parmsJson.rangos;

      console.log("BEFORE CREATE MÓDULOS:" + this.paramsNivel_2);
    }
  },
  created() {
    let parametros = this.serviceCommons.base64ToObject(
      this.$route.query.parametros
    );

    this.idFase = parametros.fase;
    this.idCeco = parametros.ceco;
    this.semana = parametros.semana;
    this.fechaSQ = parametros.fechaSQ;
    this.idUsuario = parametros.idUsuario;
    this.nombreFase = parametros.nombreFase;
    this.nombreUsuario = parametros.nombreUsuario;

    if (
      typeof this.fechaSQ == "undefined" ||
      typeof this.idUsuario == "undefined" ||
      typeof this.idFase == "undefined" ||
      typeof this.idCeco == "undefined"
    ) {
      this.alerta(
        "Error en Parámetros",
        "Sin datos suficientes para generar información"
      );
      return;
    }

    this.getModulos();
  },
  methods: {
    getModulos() {
      let fechaSQL = this.fechaSQ.replaceAll("/", "");

      if (fechaSQL.length != 6) {
        this.alerta(
          "Error en Fecha",
          "Se detectó un error en la fecha: " + this.fechaSQ
        );
        return;
      }

      let fecha_ = fechaSQL;
      let idUsuario_ = this.idUsuario;
      let idFase_ = this.idFase;
      let idCeco_ = this.idCeco;

      this.objAdd = {
        fecha: fecha_,
        idUsuario: idUsuario_,
        idFase: idFase_,
        idCeco: idCeco_,
      };

      console.log(
        "CONSUME[reporteCheckList]fecha:" +
          fecha_ +
          "|idUsuario:" +
          idUsuario_ +
          "|idFase:" +
          idFase_ +
          "|idCeco:" +
          idCeco_
      );

      axios
        .post("/asignacion-mtto/secure/get/reporteCheckList", this.objAdd)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (typeof response.data.data == "undefined") {
                this.alerta(
                  "Sin Registros",
                  "No se obtuvieron registros del usuario:" +
                    this.idUsuario +
                    ", fecha:" +
                    this.fechaSQ +
                    ", fase:" +
                    this.idFase
                );
                return;
              }

              this.modulos = response.data.data;
              this.disabledBtnDownload = false;
              console.log(
                "response.data.data:" + JSON.stringify(response.data.data)
              );
            } else {
              //this.dialogFechasNulas = true;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    crearInfoExcel() {
      let datos = this.modulos;
      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["Nombre_Checklist", "nombreChecklist"],
        ["Hora_Entrada", "horaEntrada"],
        ["Hora_Salida", "horaSalida"],
        ["Horas_Trabajadas", "horasTrabajadas"],
        ["ID_Ceco", "idCeco"],
      ];

      for (var i = 0; i < datos.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          let instrucc =
            "ass." +
            fields[j][0] +
            " = typeof(datos[i]." +
            fields[j][1] +
            ") == 'undefined' ? '' : " +
            " datos[i]." +
            fields[j][1];
          eval(instrucc);
          //console.log(instrucc)
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    downExcel() {
      //const dataFinal = this.modulos;
      const dataFinal = this.crearInfoExcel();
      console.log("Rows xls:" + dataFinal.length);
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${month}/${day}/${year}`;
    },
    alerta(titulo, mensaje) {
      this.titMensaje = titulo;
      this.txtMensaje = mensaje;
      this.dlgMensaje = true;
    },
  }, // fin metodos
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  watch: {},
};
</script>

<style>
.padding {
  padding-bottom: 25px;
}
.btnDisabled {
  color: gray;
  border: 1px solid #f7b851;
}
.parrafoCentrado {
  text-align: center;
}
.parallax {
  min-height: 100vh;
  display: flex;
  align-items: center;
}
.card__text {
  font-size: 1.2em;
  padding-top: 0;
  padding-bottom: 7%;
}
.cardTitDetalle {
  margin: 20px;
  max-width: 550px;
}
</style>
